//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C167EEB01FB.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C167EEB01FB.cm

//## begin module%3C167EEB01FB.cp preserve=no
//## end module%3C167EEB01FB.cp

//## Module: Genetic%3C167EEB01FB; Package body
//## Subsystem: XSFit::FitMethod::Unimplemented::Genetic%3C167E52034C
//## Source file: /local/data/xerxes1/gordon/Xspec/src/XSFit/FitMethod/Unimplemented/Genetic/Genetic.cxx

//## begin module%3C167EEB01FB.additionalIncludes preserve=no
//## end module%3C167EEB01FB.additionalIncludes

//## begin module%3C167EEB01FB.includes preserve=yes
//## end module%3C167EEB01FB.includes

// Genetic
#include <XSFit/FitMethod/Unimplemented/Genetic/Genetic.h>
//## begin module%3C167EEB01FB.declarations preserve=no
//## end module%3C167EEB01FB.declarations

//## begin module%3C167EEB01FB.additionalDeclarations preserve=yes
#include "Error/Error.h"
#include <typeinfo>
//## end module%3C167EEB01FB.additionalDeclarations


// Class Genetic 

Genetic::Genetic(const Genetic &right)
  //## begin Genetic::Genetic%3B7AE1D70230_copy.hasinit preserve=yes
  : FitMethod(right), 
    m_numberOfGenerations(right.m_numberOfGenerations),
    m_init(right.m_init)
  //## end Genetic::Genetic%3B7AE1D70230_copy.hasinit
  //## begin Genetic::Genetic%3B7AE1D70230_copy.initialization preserve=yes
  //## end Genetic::Genetic%3B7AE1D70230_copy.initialization
{
  //## begin Genetic::Genetic%3B7AE1D70230_copy.body preserve=yes
  //## end Genetic::Genetic%3B7AE1D70230_copy.body
}

Genetic::Genetic (const std::string& initString)
  //## begin Genetic::Genetic%3C190AA50127.hasinit preserve=yes
   : FitMethod("genetic",initString),m_numberOfGenerations(500),m_init(false)
  //## end Genetic::Genetic%3C190AA50127.hasinit
  //## begin Genetic::Genetic%3C190AA50127.initialization preserve=yes
  //## end Genetic::Genetic%3C190AA50127.initialization
{
  //## begin Genetic::Genetic%3C190AA50127.body preserve=yes
  //## end Genetic::Genetic%3C190AA50127.body
}



//## Other Operations (implementation)
void Genetic::doPerform (Fit* fit)
{
  //## begin Genetic::doPerform%3B7AE9A901CE.body preserve=yes
  //## end Genetic::doPerform%3B7AE9A901CE.body
}

void Genetic::doProcessMethodString (const string& methodInput)
{
  //## begin Genetic::doProcessMethodString%3C1A5D360238.body preserve=yes
  //## end Genetic::doProcessMethodString%3C1A5D360238.body
}

Genetic* Genetic::clone () const
{
  //## begin Genetic::clone%3C84EBAE005D.body preserve=yes
  return new Genetic(*this);
  //## end Genetic::clone%3C84EBAE005D.body
}

void Genetic::copy (const FitMethod& right)
{
  //## begin Genetic::copy%3C84EBC2020A.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  Genetic that(static_cast<const Genetic&>(right));
  swap(that);   
  //## end Genetic::copy%3C84EBC2020A.body
}

void Genetic::swap (FitMethod& right)
{
  //## begin Genetic::swap%3C84F139005C.body preserve=yes
  FitMethod::swap(right);
  Genetic&  that = static_cast<Genetic&>(right);
  std::swap(m_init,that.m_init);
  std::swap(m_numberOfGenerations,that.m_numberOfGenerations);
  //## end Genetic::swap%3C84F139005C.body
}

string Genetic::fullName () const
{
  //## begin Genetic::fullName%3FCE0CE6019F.body preserve=yes
  return string("Genetic");
  //## end Genetic::fullName%3FCE0CE6019F.body
}

// Additional Declarations
  //## begin Genetic%3B7AE1D70230.declarations preserve=yes
  //## end Genetic%3B7AE1D70230.declarations

//## begin module%3C167EEB01FB.epilog preserve=yes
//## end module%3C167EEB01FB.epilog
